#include <sys/types.h>
#include <sys/socket.h>
#include <arpa/inet.h>
#include <stdlib.h>
#include <errno.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>

int main(int argc, char * argv[])
{
  int sockfd, rec_sock;
  socklen_t len;
  char address[INET_ADDRSTRLEN];
  
  struct sockaddr_in addr, recaddr;

  if (argc < 2) 
  {
    fprintf(stderr,"USAGE: %s port.\n", argv[0]);
    exit(-1);
  }

  if ((sockfd = socket(AF_INET, SOCK_STREAM, 0)) < 0) 
  {
    perror("Cannot get socket");
    exit(1);
  }

  memset(&addr, 0, sizeof(struct sockaddr_in));
  addr.sin_addr.s_addr = htonl(INADDR_ANY);
  addr.sin_family = AF_INET;
  addr.sin_port = htons(atoi(argv[1]));

  if (bind(sockfd, (struct sockaddr *)&addr, sizeof(addr)) < 0) 
  {
    perror("bind");
    exit(1);
  }

  
  len = sizeof(addr);
  if (getsockname(sockfd, (struct sockaddr *)&addr, &len) < 0)
  {
    perror("can't get name");
    exit(1);
  }
  
  printf("ip = %s, port = %hd\n", inet_ntop(AF_INET, &addr.sin_addr, address, sizeof(address)), ntohs(addr.sin_port));

  if (listen(sockfd, 5) < 0) 
  {
    perror("listen");
    exit(1);
  }

  rec_sock = accept(sockfd, (struct sockaddr *)(&recaddr), &len);

  if (rec_sock < 0) 
  {
    perror("accept");
    exit(1);
  }

  /* print the remote socket information */

  printf("remote machine = %s, port = %hx, %hx.\n", inet_ntop(AF_INET, &recaddr.sin_addr, address, sizeof(address)), recaddr.sin_port, ntohs(recaddr.sin_port));
  
  memset(&recaddr, 0, sizeof(recaddr));
  len = sizeof(addr);
  if (getpeername(rec_sock, (struct sockaddr *)&recaddr, &len) < 0)
    {
      perror("Cannot get name");
      exit(1);
    }

  printf("remote machine = %s, port = %hx, %hx.\n", inet_ntop(AF_INET, &recaddr.sin_addr, address, sizeof(address)), recaddr.sin_port, ntohs(recaddr.sin_port));
  

  write(rec_sock, "Hello, world", strlen("Hello, world")+1);

  sleep(20);
  return (0);
}



